import './style.css';
import '@components/ErrorView';
import '@components/NostrAvatar';
import '@components/LoadingView';
import '@components/NostrProfile';
import '@components/Breadcrumbs';
import '@components/Header';
import '@routes/router';
import '@components/LoadingView';
import type EveRouter from '@routes/router';

function checkRelayUp() {
  return new Promise((resolve, reject) => {
    const timeoutId = setTimeout(() => {
      ws.close();
      reject(new Error('Connection timeout'));
    }, 5000);

    const ws = new WebSocket('ws://localhost:6942');

    ws.onopen = () => {
      clearTimeout(timeoutId);
      ws.close();
      resolve(true);
    };

    ws.onerror = (error) => {
      clearTimeout(timeoutId);
      reject(error);
    };
  });
}

async function startRelay() {
  if (localStorage.getItem('ncryptsec')) {
    const loadingIndicator = document.createElement('arx-loading-view');
    document.body.appendChild(loadingIndicator);
    await window.relay.start(localStorage.getItem('encryption_key')!);
    try {
      await checkRelayUp();
    } catch (err) {
      alert('Could not connect to relay. This might be because the relay is not running. Try restarting Eve');
    }
    loadingIndicator.remove();
  }
}

if (localStorage.getItem('darkMode') === 'true') document.body.classList.add('dark');

startRelay().then(() => {
  const router = document.createElement('arx-eve-router') as EveRouter;
  router.ccnSetup = !!localStorage.getItem('ncryptsec');
  document.body.appendChild(router);
});
